diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ManagementController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ManagementController.java
index 329cd9e493..274995df5f 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ManagementController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ManagementController.java
@@ -9,7 +9,9 @@
  */
 package eu.etaxonomy.cdm.remote.controller;
 
+import java.util.HashSet;
 import java.util.Map;
+import java.util.Set;
 import java.util.UUID;
 
 import javax.servlet.http.HttpServletRequest;
@@ -30,7 +32,6 @@ import eu.etaxonomy.cdm.database.DataSourceInfo;
 import eu.etaxonomy.cdm.database.DataSourceReloader;
 import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.remote.controller.util.ProgressMonitorUtil;
-import eu.etaxonomy.cdm.remote.dto.common.ErrorResponse;
 import eu.etaxonomy.cdm.remote.editor.CdmTypePropertyEditor;
 
 @Controller
@@ -40,208 +41,216 @@ public class ManagementController {
 			.getLogger(ManagementController.class);
 
 	// @Autowired
-	private DataSourceReloader datasoucrceLoader;
+    private DataSourceReloader datasoucrceLoader;
 
-	@Autowired
-	public ICdmMassIndexer indexer;
+    @Autowired
+    public ICdmMassIndexer indexer;
 
-	@Autowired
-	public ProgressMonitorController progressMonitorController;
+    @Autowired
+    public ProgressMonitorController progressMonitorController;
 
-	/**
-	 * There should only be one processes operating on the lucene index
+    /**
+     * There should only be one processes operating on the lucene index
 	 * therefore the according progress monitor uuid is stored in this static
 	 * field.
-	 */
-	private static UUID indexMonitorUuid = null;
+     */
+    private static UUID indexMonitorUuid = null;
 
 	@InitBinder
 	public void initIndexClassBinder(WebDataBinder binder) {
 		binder.registerCustomEditor(Class.class, new CdmTypePropertyEditor());
 	}
-	
+
 	@InitBinder
 	public void initIndexArrayBinder(WebDataBinder binder) {
 		binder.registerCustomEditor(Class[].class, new CdmTypePropertyEditor());
 	}
 
-	/*
-	 * return page not found http error (404) for unknown or incorrect UUIDs
-	 * (non-Javadoc)
-	 * 
+    /*
+     * return page not found http error (404) for unknown or incorrect UUIDs
+     * (non-Javadoc)
+     *
 	 * @see
 	 * org.springframework.web.servlet.mvc.AbstractController#handleRequestInternal
 	 * (javax.servlet.http.HttpServletRequest,
 	 * javax.servlet.http.HttpServletResponse)
-	 */
+     */
 	// @RequestMapping(value = { "/manager/datasources/list" }, method =
 	// RequestMethod.GET)
 	protected ModelAndView doList(HttpServletRequest request,
 			HttpServletResponse respone) throws Exception {
 
-		ModelAndView mv = new ModelAndView();
-		Map<String, DataSourceInfo> dataSourceInfos = datasoucrceLoader.test();
-		mv.addObject(dataSourceInfos);
+        ModelAndView mv = new ModelAndView();
+        Map<String, DataSourceInfo> dataSourceInfos = datasoucrceLoader.test();
+        mv.addObject(dataSourceInfos);
 
-		return mv;
-	}
+        return mv;
+    }
 
 	// @RequestMapping(value = { "/manager/datasources/reload" }, method =
 	// RequestMethod.GET)
 	public ModelAndView doReload(HttpServletRequest request,
 			HttpServletResponse respone) throws Exception {
 
-		ModelAndView mv = new ModelAndView();
+        ModelAndView mv = new ModelAndView();
 		Map<String, DataSourceInfo> dataSourceInfos = datasoucrceLoader
 				.reload();
-		mv.addObject(dataSourceInfos);
+        mv.addObject(dataSourceInfos);
 
-		return mv;
-	}
+        return mv;
+    }
 
-	/**
-	 * 
+    /**
+     *
 	 * Reindex all cdm entities listed in
 	 * {@link ICdmMassIndexer#indexedClasses()}. Re-indexing will not purge the
 	 * index.
-	 * 
+     *
 	 * @param frontendBaseUrl
 	 *            if the CDM server is running behind a reverse proxy you need
-	 *            to supply the base URL of web service front-end which is
-	 *            provided by the proxy server.
-	 * @param request
-	 * @param respone
-	 * @return
-	 * @throws Exception
-	 */
-	@RequestMapping(value = { "reindex" }, method = RequestMethod.GET)
-	public ModelAndView doReindex(
-			@RequestParam(value = "frontendBaseUrl", required = false) String frontendBaseUrl,
+     *            to supply the base URL of web service front-end which is
+     *            provided by the proxy server.
+     * @param request
+     * @param respone
+     * @return
+     * @throws Exception
+     */
+    @RequestMapping(value = { "reindex" }, method = RequestMethod.GET)
+    public synchronized ModelAndView doReindex(
+             @RequestParam(value = "frontendBaseUrl", required = false) String frontendBaseUrl,
 			@RequestParam(value = "type", required = false) Class<? extends CdmBase>[] types,
-			@RequestParam(value = "priority", required = false) Integer priority,
+             @RequestParam(value = "priority", required = false) Integer priority,
 			HttpServletRequest request, HttpServletResponse response)
 			throws Exception {
-		
-		indexer.clearIndexedClasses();
-		if(types != null) {
-			for (Class<? extends CdmBase> type : types) {
-				if(type != null) {
-					indexer.addToIndexedClasses(type);
-				}
-			}
-		}
-		
-		String processLabel = "Re-indexing";
+
+        final Set<Class<? extends CdmBase>> typeSet = asList(types);
+
+        String processLabel = "Re-indexing";
 		ProgressMonitorUtil progressUtil = new ProgressMonitorUtil(
 				progressMonitorController);
 
 		if (!progressMonitorController.isMonitorRunning(indexMonitorUuid)) {
-			indexMonitorUuid = progressUtil.registerNewMonitor();
+            indexMonitorUuid = progressUtil.registerNewMonitor();
 			Thread subThread = new Thread() {
-				@Override
+                @Override
 				public void run() {
-					indexer.reindex(progressMonitorController
-							.getMonitor(indexMonitorUuid));
-				}
-			};
+                    indexer.reindex(typeSet, progressMonitorController.getMonitor(indexMonitorUuid));
+                }
+            };
 			if (priority == null) {
-				priority = AbstractController.DEFAULT_BATCH_THREAD_PRIORITY;
-			}
-			subThread.setPriority(priority);
-			subThread.start();
-		}
-		// send redirect "see other"
+                priority = AbstractController.DEFAULT_BATCH_THREAD_PRIORITY;
+            }
+            subThread.setPriority(priority);
+            subThread.start();
+        }
+        // send redirect "see other"
 		return progressUtil.respondWithMonitor(frontendBaseUrl, request,
 				response, processLabel, indexMonitorUuid);
-	}
+    }
+
+    /**
+     * @param types
+     */
+    private Set<Class<? extends CdmBase>> asList(Class<? extends CdmBase>[] types) {
+        Set<Class<? extends CdmBase>> typeSet = null;
+        if(types != null) {
+            typeSet = new HashSet<Class<? extends CdmBase>>();
+            for (Class<? extends CdmBase> type : types) {
+                if(type != null) {
+                    typeSet.add(type);
+                }
+            }
+        }
+        return typeSet;
+    }
 
-	/**
-	 * 
+    /**
+     *
 	 * Create dictionaries for all cdm entities listed in
 	 * {@link ICdmMassIndexer#dictionaryClasses()}. Re-dicting will not purge
 	 * the dictionaries.
-	 * 
+     *
 	 * @param frontendBaseUrl
 	 *            if the CDM server is running behind a reverse proxy you need
-	 *            to supply the base URL of web service front-end which is
-	 *            provided by the proxy server.
-	 * @param request
-	 * @param respone
-	 * @return
-	 * @throws Exception
-	 */
-	@RequestMapping(value = { "redict" }, method = RequestMethod.GET)
-	public ModelAndView doRedict(
-			@RequestParam(value = "frontendBaseUrl", required = false) String frontendBaseUrl,
-			@RequestParam(value = "priority", required = false) Integer priority,
+    *            to supply the base URL of web service front-end which is
+    *            provided by the proxy server.
+    * @param request
+    * @param respone
+    * @return
+    * @throws Exception
+    */
+   @RequestMapping(value = { "redict" }, method = RequestMethod.GET)
+    public synchronized ModelAndView doRedict(
+            @RequestParam(value = "frontendBaseUrl", required = false) String frontendBaseUrl,
+            @RequestParam(value = "priority", required = false) Integer priority,
 			HttpServletRequest request, HttpServletResponse response)
 			throws Exception {
 
-		String processLabel = "Re-Dicting";
+       String processLabel = "Re-Dicting";
 		ProgressMonitorUtil progressUtil = new ProgressMonitorUtil(
 				progressMonitorController);
 
 		if (!progressMonitorController.isMonitorRunning(indexMonitorUuid)) {
-			indexMonitorUuid = progressUtil.registerNewMonitor();
+           indexMonitorUuid = progressUtil.registerNewMonitor();
 			Thread subThread = new Thread() {
-				@Override
+               @Override
 				public void run() {
 					indexer.createDictionary(progressMonitorController
 							.getMonitor(indexMonitorUuid));
-				}
-			};
+               }
+           };
 			if (priority == null) {
-				priority = AbstractController.DEFAULT_BATCH_THREAD_PRIORITY;
-			}
-			subThread.setPriority(priority);
-			subThread.start();
-		}
-		// send redirect "see other"
+               priority = AbstractController.DEFAULT_BATCH_THREAD_PRIORITY;
+           }
+           subThread.setPriority(priority);
+           subThread.start();
+       }
+       // send redirect "see other"
 		return progressUtil.respondWithMonitor(frontendBaseUrl, request,
 				response, processLabel, indexMonitorUuid);
-	}
+   }
 
-	/**
-	 * This will wipe out the index.
-	 * 
-	 * @param request
-	 * @param respone
-	 * @return
-	 * @throws Exception
-	 */
-	@RequestMapping(value = { "purge" }, method = RequestMethod.GET)
-	public ModelAndView doPurge(
-			@RequestParam(value = "frontendBaseUrl", required = false) String frontendBaseUrl,
-			@RequestParam(value = "priority", required = false) Integer priority,
+    /**
+     * This will wipe out the index.
+     *
+     * @param request
+     * @param respone
+     * @return
+     * @throws Exception
+     */
+    @RequestMapping(value = { "purge" }, method = RequestMethod.GET)
+    public synchronized ModelAndView doPurge(
+            @RequestParam(value = "frontendBaseUrl", required = false) String frontendBaseUrl,
+            @RequestParam(value = "priority", required = false) Integer priority,
 			HttpServletRequest request, HttpServletResponse response)
 			throws Exception {
 
-		String processLabel = "Purging";
+        String processLabel = "Purging";
 
 		ProgressMonitorUtil progressUtil = new ProgressMonitorUtil(
 				progressMonitorController);
 
 		if (!progressMonitorController.isMonitorRunning(indexMonitorUuid)) {
-			indexMonitorUuid = progressUtil.registerNewMonitor();
+            indexMonitorUuid = progressUtil.registerNewMonitor();
 			Thread subThread = new Thread() {
-				@Override
+                @Override
 				public void run() {
 					indexer.purge(progressMonitorController
 							.getMonitor(indexMonitorUuid));
-				}
-			};
+                }
+            };
 			if (priority == null) {
-				priority = AbstractController.DEFAULT_BATCH_THREAD_PRIORITY;
-			}
-			subThread.setPriority(priority);
-			subThread.start();
-		}
+                priority = AbstractController.DEFAULT_BATCH_THREAD_PRIORITY;
+            }
+            subThread.setPriority(priority);
+            subThread.start();
+        }
 
-		// send redirect "see other"
+        // send redirect "see other"
 		return progressUtil.respondWithMonitor(frontendBaseUrl, request,
 				response, processLabel, indexMonitorUuid);
-	}
-	
-	
+    }
+
+
 
 }
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrenceController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrenceController.java
index 5dca1216fb..351a774681 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrenceController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrenceController.java
@@ -27,7 +27,7 @@ import org.springframework.web.servlet.ModelAndView;
 
 import eu.etaxonomy.cdm.api.service.IOccurrenceService;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 
 /**
@@ -71,8 +71,8 @@ public class OccurrenceController extends BaseController<SpecimenOrObservationBa
 
         ModelAndView mv = new ModelAndView();
         SpecimenOrObservationBase sob = getCdmBaseInstance(uuid, response, DERIVED_UNIT_INIT_STRATEGY);
-        if(sob instanceof DerivedUnitBase){
-            DerivationEvent derivationEvent = ((DerivedUnitBase)sob).getDerivedFrom();
+        if(sob instanceof DerivedUnit){
+            DerivationEvent derivationEvent = ((DerivedUnit)sob).getDerivedFrom();
             if (derivationEvent != null) {
                 mv.addObject(derivationEvent);
             }
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrencePortalController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrencePortalController.java
index a1c3290915..2b7b86f3b0 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrencePortalController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/OccurrencePortalController.java
@@ -27,7 +27,7 @@ import org.springframework.web.servlet.ModelAndView;
 
 import eu.etaxonomy.cdm.api.service.IOccurrenceService;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 
 /**
@@ -89,8 +89,8 @@ public class OccurrencePortalController extends BaseController<SpecimenOrObserva
         List<String> initStrategy = DEFAULT_INIT_STRATEGY;
 
         SpecimenOrObservationBase sob = getCdmBaseInstance(uuid, response, initStrategy);
-        if(sob instanceof DerivedUnitBase){
-            DerivationEvent derivationEvent = ((DerivedUnitBase)sob).getDerivedFrom();
+        if(sob instanceof DerivedUnit){
+            DerivationEvent derivationEvent = ((DerivedUnit)sob).getDerivedFrom();
             mv.addObject(derivationEvent);
         }
         return mv;
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/StatisticsController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/StatisticsController.java
index 7dfef015c7..8d3f1e8f77 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/StatisticsController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/StatisticsController.java
@@ -1,7 +1,11 @@
 package eu.etaxonomy.cdm.remote.controller;
 
 import java.io.IOException;
+import java.util.ArrayList;
+import java.util.HashSet;
 import java.util.List;
+import java.util.Set;
+import java.util.UUID;
 
 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.http.HttpServletResponse;
@@ -14,26 +18,34 @@ import org.springframework.web.bind.annotation.RequestMethod;
 import org.springframework.web.bind.annotation.RequestParam;
 import org.springframework.web.servlet.ModelAndView;
 
+import eu.etaxonomy.cdm.api.service.IClassificationService;
 import eu.etaxonomy.cdm.api.service.IStatisticsService;
 import eu.etaxonomy.cdm.api.service.statistics.Statistics;
 import eu.etaxonomy.cdm.api.service.statistics.StatisticsConfigurator;
 import eu.etaxonomy.cdm.api.service.statistics.StatisticsPartEnum;
 import eu.etaxonomy.cdm.api.service.statistics.StatisticsTypeEnum;
+import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
+import eu.etaxonomy.cdm.model.taxon.Classification;
+import eu.etaxonomy.cdm.persistence.query.MatchMode;
 
 /**
- * @author sybille
- * @created 07.11.2012 this class provides counting of different entities in a
- *          database
+ * this controller provides a method to count different entities in the entire
+ * database as well as from a particular classification items of different types
+ * can be choosen have a look at doStatistics method
+ * 
+ * @author s.buers
+ * @created 07.11.2012
  * 
  */
 @Controller
-@RequestMapping(value = { "/statistic" })
+@RequestMapping(value = { "/statistics" })
 public class StatisticsController {
 
 	private static final Logger logger = Logger
 			.getLogger(StatisticsController.class);
 
-	private static final List<StatisticsTypeEnum> D = null;
+	@Autowired
+	private IClassificationService classificationService;
 
 	private IStatisticsService service;
 
@@ -42,8 +54,6 @@ public class StatisticsController {
 		this.service = service;
 	}
 
-	StatisticsConfigurator configurator;
-
 	/**
 	 * example query:
 	 * 
@@ -62,43 +72,103 @@ public class StatisticsController {
 	public ModelAndView doStatistics(
 			@RequestParam(value = "part", required = false) String[] part,
 			@RequestParam(value = "type", required = false) String[] type,
+			@RequestParam(value = "classificationName", required = false) String[] classificationName,
+			@RequestParam(value = "classificationUuid", required = false) String[] classificationUuid,
 			HttpServletRequest request, HttpServletResponse response)
 			throws IOException {
 
-		configurator = new StatisticsConfigurator();
 		ModelAndView mv = new ModelAndView();
 
-		createConfigurator(part, type);
-		// service.getStatistics(configurator);
-		Statistics statistics = service.getCountStatistics(configurator);
+		List<StatisticsConfigurator> configuratorList = createConfiguratorList(
+				part, type, classificationName, classificationUuid);
+		List<Statistics> statistics = service
+				.getCountStatistics(configuratorList);
 		logger.info("doStatistics() - " + request.getRequestURI());
 
 		mv.addObject(statistics);
 		return mv;
 	}
 
-	private void createConfigurator(String[] part, String[] type) {
+	private List<StatisticsConfigurator> createConfiguratorList(String[] part,
+			String[] type, String[] classificationName,
+			String[] classificationUuid) {
 
-		if (part != null) {
-			for (String string : part) {
-				configurator.addPart(StatisticsPartEnum.valueOf(string));
-			}
-		} else
-			configurator.addPart(StatisticsPartEnum.ALL);
+		ArrayList<StatisticsConfigurator> configuratorList = new ArrayList<StatisticsConfigurator>();
+
+		// 1. get types for configurators:
+		// in our case all the configurators will have the same types
+		// so we calculate the types once and save them in a helperConfigurator
+		StatisticsConfigurator helperConfigurator = new StatisticsConfigurator();
 
 		if (type != null) {
 			for (String string : type) {
-				configurator.addType(StatisticsTypeEnum.valueOf(string));
+				helperConfigurator.addType(StatisticsTypeEnum.valueOf(string));
 			}
-		} else
-			setDefaultType();
-	}
+		} else { // if nothing is chosen, count all:
+			for (StatisticsTypeEnum enumValue : StatisticsTypeEnum.values()) {
+				helperConfigurator.addType(enumValue);
+			}
+		}
+
+		// 2. determine the search areas (entire db, all classifications or
+		// specific classifications) and put
+		// each of them in a configurator:
+
+		// gather classifications from names and uuids:
+
+		Set<Classification> classificationFilters = new HashSet<Classification>();
 
-	private void setDefaultType() {
-		// for default choose all types:
-		for (StatisticsTypeEnum type : StatisticsTypeEnum.values()) {
-			configurator.addType(type);
+		if (classificationName != null) {
+			for (String string : classificationName) {
+					List <Classification> classifications = classificationService
+							.listByTitle(Classification.class, string,
+									MatchMode.EXACT, null, null, null, null,
+									null);
+					classificationFilters.addAll(classifications);
+				
+			}
+		}
+		if (classificationUuid != null && classificationUuid.length > 0) {
+			for (String string : classificationUuid) {
+				if (classificationService.exists(UUID.fromString(string))) {
+					classificationFilters.add(classificationService.find(UUID
+							.fromString(string)));
+				}
+			}
 		}
 
+		// if no part at all was given:
+		if (part == null && classificationFilters.isEmpty()) {
+			helperConfigurator.addFilter(service.getFilterALL_DB());
+			configuratorList.add(helperConfigurator);
+		}
+
+		// else parse list of parts and create configurator for each:
+		if (part != null) {
+			helperConfigurator.addFilter(service.getFilterALL_DB());
+			for (String string : part) {
+				// System.out.println(StatisticsPartEnum.ALL.toString());
+				if (string.equals(StatisticsPartEnum.ALL.toString())) {
+					configuratorList.add(helperConfigurator);
+				} else if (string.equals(StatisticsPartEnum.CLASSIFICATION
+						.toString())) {
+					List<Classification> classificationsList = classificationService
+							.listClassifications(null, 0, null, null);
+					classificationFilters.addAll(classificationsList);
+
+				}
+			}
+		}
+		for (Classification classification : classificationFilters) {
+
+			StatisticsConfigurator newConfigurator = new StatisticsConfigurator();
+			newConfigurator.setType(helperConfigurator.getType());
+			newConfigurator.getFilter().addAll(helperConfigurator.getFilter());
+			newConfigurator.addFilter(classification);
+			configuratorList.add(newConfigurator);
+		}
+
+		return configuratorList;
 	}
+
 }
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonListController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonListController.java
index c64f9f929d..7f906cca53 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonListController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonListController.java
@@ -29,9 +29,10 @@ import org.springframework.web.bind.annotation.RequestParam;
 import eu.etaxonomy.cdm.api.service.IClassificationService;
 import eu.etaxonomy.cdm.api.service.ITaxonService;
 import eu.etaxonomy.cdm.api.service.ITermService;
-import eu.etaxonomy.cdm.api.service.config.IFindTaxaAndNamesConfigurator;
 import eu.etaxonomy.cdm.api.service.config.FindTaxaAndNamesConfiguratorImpl;
+import eu.etaxonomy.cdm.api.service.config.IFindTaxaAndNamesConfigurator;
 import eu.etaxonomy.cdm.api.service.pager.Pager;
+import eu.etaxonomy.cdm.api.service.search.LuceneMultiSearchException;
 import eu.etaxonomy.cdm.api.service.search.SearchResult;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.Language;
@@ -160,7 +161,7 @@ public class TaxonListController extends IdentifiableListController<TaxonBase, I
             config.setClassification(classification);
         }
 
-        return (Pager<IdentifiableEntity>) service.findTaxaAndNames(config);
+        return service.findTaxaAndNames(config);
 
     }
 
@@ -267,7 +268,7 @@ public class TaxonListController extends IdentifiableListController<TaxonBase, I
             HttpServletRequest request,
             HttpServletResponse response
             )
-             throws IOException, ParseException {
+             throws IOException, ParseException, LuceneMultiSearchException {
 
          logger.info("findByEverythingFullText : " + request.getRequestURI() + "?" + request.getQueryString() );
 
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonPortalController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonPortalController.java
index 4230d22ca1..caea41a2c2 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonPortalController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/TaxonPortalController.java
@@ -967,7 +967,7 @@ public class TaxonPortalController extends BaseController<TaxonBase, ITaxonServi
             //Check if TaxonNode belongs to the current tree
 
             node = classificationService.loadTaxonNode(node, TAXONNODE_WITHTAXON_INIT_STRATEGY);
-            Set<TaxonNode> children = node.getChildNodes();
+            List<TaxonNode> children = node.getChildNodes();
             Taxon childTaxon;
             for (TaxonNode child : children){
                 childTaxon = child.getTaxon();
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/dto/NameCatalogueController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/dto/NameCatalogueController.java
index fa3cf59e8c..fa0fe4f66f 100755
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/dto/NameCatalogueController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/dto/NameCatalogueController.java
@@ -122,6 +122,12 @@ public class NameCatalogueController extends BaseController<TaxonNameBase, IName
     /** Classifcation 'all' key */
     public static final String CLASSIFICATION_ALL = "all";
     
+    /** Fuzzy Name Cache search */
+    public static final String FUZZY_NAME_CACHE = "name";
+    
+    /** Fuzzy Atomised Name search */
+    public static final String FUZZY_ATOMISED = "atomised";
+    
     private static final String DWC_DATASET_ID = "http://rs.tdwg.org/dwc/terms/datasetID";
 
     private static final DateTimeFormatter fmt = DateTimeFormat.forPattern("dd-MM-yyyy");
@@ -423,7 +429,7 @@ public class NameCatalogueController extends BaseController<TaxonNameBase, IName
 
             } else {
                 ErrorResponse er = new ErrorResponse();
-                er.setErrorMessage("No Taxon Name matches : " + query + ", for given accuracy");
+                er.setErrorMessage("No Taxon Name matches : " + query);
                 nsList.add(er);
             }
         }        
@@ -482,7 +488,11 @@ public class NameCatalogueController extends BaseController<TaxonNameBase, IName
      *                Briefly described, this is equivalent to the edit distance between the two words, divided by 
      *                the length of the shorter of the compared terms.
      * @param hits               
-     *            Maximum number of responses to be returned.    
+     *            Maximum number of responses to be returned.
+     * @param type               
+     *            The type of fuzzy search to call. This can be either
+     *              "name" : fuzzy searches scientific names corresponding to 'name cache' in CDM or
+     *              "atomised" : parses the query into atomised elements and fuzzy searches the individual elements in the CDM      
      * @param request Http servlet request.
      * @param response Http servlet response.
      * @return a List of {@link NameSearch} objects each corresponding to a
@@ -494,6 +504,7 @@ public class NameCatalogueController extends BaseController<TaxonNameBase, IName
     public ModelAndView doGetNameFuzzySearch(@RequestParam(value = "query", required = true) String[] queries,
     		@RequestParam(value = "accuracy", required = false, defaultValue = "0.6") String accuracy,
     		@RequestParam(value = "hits", required = false, defaultValue = "10") String hits,
+    		@RequestParam(value = "type", required = false, defaultValue = FUZZY_NAME_CACHE) String type,
             HttpServletRequest request, HttpServletResponse response) throws IOException {
         ModelAndView mv = new ModelAndView();
         List<RemoteResponse> nsList = new ArrayList<RemoteResponse>();
@@ -532,14 +543,23 @@ public class NameCatalogueController extends BaseController<TaxonNameBase, IName
             logger.info("doGetNameSearch()" + request.getRequestURI() + " for query \"" + queryWOWildcards + " with accuracy " + accuracy);
             //List<NonViralName> nameList = new ArrayList<NonViralName>();
             List<DocumentSearchResult> nameSearchList = new ArrayList<DocumentSearchResult>();
-            try {            	            
-				nameSearchList = service.findByNameFuzzySearch(
-				        queryWOWildcards,
-				        acc,
-				        null,
-				        false, 
-				        h);
-			} catch (ParseException e) {
+            try {       
+            	if(type.equals(FUZZY_ATOMISED)) {
+            		nameSearchList = service.findByNameFuzzySearch(
+            				queryWOWildcards,
+            				acc,
+            				null,
+            				false, 
+            				h);
+            	} else {
+            		nameSearchList = service.findByFuzzyNameCacheSearch(
+            				queryWOWildcards,
+            				acc,
+            				null,
+            				false, 
+            				h);
+            	}
+            } catch (ParseException e) {
 				// TODO Auto-generated catch block
 				//e.printStackTrace();
 				ErrorResponse er = new ErrorResponse();
diff --git a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ext/ExternalGeoController.java b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ext/ExternalGeoController.java
index 195f311b14..3c0b760308 100644
--- a/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ext/ExternalGeoController.java
+++ b/cdmlib-remote/src/main/java/eu/etaxonomy/cdm/remote/controller/ext/ExternalGeoController.java
@@ -39,12 +39,13 @@ import eu.etaxonomy.cdm.api.service.pager.Pager;
 import eu.etaxonomy.cdm.api.service.util.TaxonRelationshipEdge;
 import eu.etaxonomy.cdm.database.UpdatableRoutingDataSource;
 import eu.etaxonomy.cdm.ext.geo.IEditGeoService;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
-import eu.etaxonomy.cdm.model.description.Scope;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
+import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
@@ -142,7 +143,7 @@ public class ExternalGeoController extends BaseController<TaxonBase, ITaxonServi
         //languages
         List<Language> langs = LocaleContext.getLanguages();
 
-        Set<Scope> scopes = null;
+        Set<DefinedTerm> scopes = null;
         Set<NamedArea> geographicalScope = null;
         Integer pageSize = null;
         Integer pageNumber = null;
@@ -185,7 +186,7 @@ public class ExternalGeoController extends BaseController<TaxonBase, ITaxonServi
         String bbox = null;
         String backLayer = null;
         Boolean doReturnImage = null;
-        Map<Class<? extends SpecimenOrObservationBase>, Color> specimenOrObservationTypeColors = null;
+        Map<SpecimenOrObservationType, Color> specimenOrObservationTypeColors = null;
 
         logger.info("doGetOccurrenceMapUriParams() " + request.getRequestURI() + "?" + request.getQueryString());
         ModelAndView mv = new ModelAndView();
